from adventurelib_gui import *
import os

Room.items = Bag()
Room.monsters = Bag()
inventory = Bag()
player_hp = 10

toy = Item("a cat toy", "cat toy", "toy")
toy.damage = 10

monster = Item("a monster", "monster")
monster.hp = 20
monster.attack = 3

bedroom = Room("""
You are in a <b>bedroom</b>.
There is a door to the north.
""")

bedroom.monsters.add(monster)

hallway = Room("""
You are in a <b>hallway</b>.
""")

hallway.items.add(toy)

bedroom.north = hallway


current_room = bedroom

@when("north", direction="north")
@when("south", direction="south")
@when("east", direction="east")
@when("west", direction="west")
def go(direction):
    global current_room
    room = current_room.exit(direction)
    if room:
        current_room = room
        say(f"You go {direction}")
        look()
    else:
        say(f"No exit {direction}")

@when('look')
def look():
    global player_hp
    say(current_room)
    for i in current_room.items:
        say(f"<i>{i}</i> is here.")
    for m in current_room.monsters:
        player_hp = player_hp - m.attack
        say(f"<b>{m} hits you. Your hp is {player_hp}</b>")
        if player_hp <= 0:
            say("<b>You died!</b>")
            os._exit(1)

@when('take ITEM')
def take(item):
    obj = current_room.items.take(item)
    if obj:
        say(f"You pick up {obj}")
        inventory.add(obj)
    else:
        say(f"There is no {item} here.")

@when('drop ITEM')
def drop(item):
    obj = inventory.take(item)
    if obj:
        say(f"You drop {obj}")
        current_room.items.add(obj)
    else:
        say(f"You do not have {item}")

@when('inventory')
def show_inventory():
    say('You have:')
    for thing in inventory:
        say(thing)

@when("attack THING with ITEM")
def attack(thing, item):
    weapon = inventory.find(item)
    enemy = current_room.monsters.find(thing)
    if weapon and enemy:
        say(f"You hit <i>{enemy}</i> with <i>{weapon}</i>")
        enemy.hp = enemy.hp - weapon.damage
        say(f"{enemy} hp is {enemy.hp}")
        if enemy.hp <= 0:
            say(f"<b>You killed {monster}!</b>")
            current_room.monsters.remove(enemy)
        else:
            look()
    else:
        say("Unable to do that.")


look()
start()

